# tplace

Interactively place raster images into a very* zoomable canvas with translation, rotation, and scale, and render an XYZ tile set composed of the placed images.

&#42; How zoomable? A typical tile-based slippy map supports zoom level 0 to roughly 30. The maximum safely representable number in JavaScript is roughly 2<sup>53</sup>. So it's safe to assume a typical tile-based slippy map supports at most 2<sup>53</sup> tile rows or columns at maximum zoom, making the maximum zoom 53. `tplace` uses [shardedmapview](https://github.com/gimlids/shardedmapview) in order to splice together a huge number of standard slippy maps into one global slippy map, thereby supporting <span style="font-size: 20px">2<sup>2<sup>53</sup></sup></span> tile rows or columns at maximum zoom, making the maximum zoom 2<sup>53</sup>.

You can use [shardedmapview](https://github.com/gimlids/shardedmapview) to render your very zoomy tile set. Example: [Powers of Ten](https://github.com/gimlids/powers-of-ten), an interactive remake of the [famous film](https://www.youtube.com/watch?v=0fKBhvDjuy0). Powers of Ten zooms from the known universe (14 light years) to the interior of a proton (10<sup>-15</sup> meters), or 150 zoom levels.

## 1. Install

Install globally with `yarn` or `npm` and you'll get the `tplace` binary in your command line.

```
sudo yarn global add tplace
```

or

```
npm install -g tplace
```

## 2. Place raster images into a slippy canvas

```
tplace edit
```

<i>TODO: screencast gif of basic placement interaction</i>

Placed images and their positions, rotations, and scales are stored in the current working directory.

## 3. Render an XYZ tile set

```
tplace render png8
```

or

```
tplace render jpeg
```

with custom zoom range

```
tplace render jpeg --min-zoom -70 --max-zoom 50
```

These render an XYZ tile set into `tiles/` in the current working directory, variably using 8-bit PNG or JPEG compression. 8-bit PNG is good for web delivery of low color graphic art. Sorry, you can't set the JPEG quality or use PNG24 right now :/

The zoom range defaults to something, but you can control the min and/or max.

Super alpha incomplete but capable software available to you with no warranty!

