const fs = require('fs');
const { spawn } = require('child_process');

module.exports = ({quality}) => ({
	imageExtension: () => 'jpg',
	export: (canvas, path, cb) => {

		var out = fs.createWriteStream(
			path
		);
		var stream = canvas.jpegStream({quality});
		 
		stream.on('data', function(chunk) {
		  out.write(chunk);
		});
		 
		stream.on('error', function() {
			cb({info: 'jpegStream emitted an error', arguments});
		});

		stream.on('end', function(){
			out.end();
		});

		out.on('finish', () => {

			console.log('Saved ' + path);
			cb(null);


		});
	}
});