const fs = require('fs');
const { spawn } = require('child_process');

module.exports = {
	imageExtension: () => 'png',
	export: (canvas, path, cb) => {
		const intermediateImagePath = path + '.intermediate.png'

		var out = fs.createWriteStream(
			intermediateImagePath
		);
		// var stream = canvas.jpegStream({
		// 	quality: 75
		// });
		var stream = canvas.pngStream();
		 
		stream.on('data', function(chunk) {
		  out.write(chunk);
		});
		 
		stream.on('error', function() {
			cb({info: 'pngStream emitted an error', arguments});
		});

		stream.on('end', function(){
			out.end();
		});

		out.on('finish', () => {
		  
		  
			  const convert = spawn('gm', [
				'convert',
				'-format', 'png8',
				intermediateImagePath,
				path
			  ]);

			  convert.stdout.on('data', (data) => {
				  console.log(`stdout: ${data}`);
				});

				convert.stderr.on('data', (data) => {
				  console.log(`stderr: ${data}`);
				});

				convert.on('close', (code) => {
				  if(code !== 0) {
				  	cb('gm convert to png8 failed');
				  }
				  else {
				  	fs.unlink(intermediateImagePath, err => {
				  		if(err) {
				  			console.error('Could not remove intermediate tile image file ' + intermediateImagePath);
				  			cb(err);
				  		}
				  		else {
				  			console.log('Saved ' + path);
				  			cb(null);
				  		}
				  		
				  	});
				  }
				});

		});
	}
}