var path = require('path'),
    fs = require('fs');

module.exports = {
	open: (sceneFilePath, cb) => fs.readFile(
		sceneFilePath,
		{encoding: 'utf8'},
		(err, data) => {
			if(err) {
				if(err.code === 'ENOENT') {
					cb(`It looks like you haven't placed any images yet (because there is no file called ${sceneFilePath} in the current directory). Use the \`edit\` command to place some images!`);
				}
				else {
					cb(err);
				}
			}
			else {
				cb(null, {
					images: JSON.parse(data)
				})
			}
		}
	)
}
