#!/usr/bin/env node

const argv = require('yargs').argv;
const requestedCommand = argv._[0];

const cliName = require('./package.json').name;
const commands = {
  // edit: require('./edit'),
  // render: require('./render')
  edit: true,
  render: true,
  'tiles-covering-point': true,
  info: true,
  row: true,
  grid: true
};

const requireCommand = name => require(`./${name}`);

const commandUsage = ({commandName}) => {
  const command = requireCommand(commandName);
  return `\`${cliName} ${commandName} ${command.usage.commandLine()}\` - ${command.usage.description()}\n`;
}

if(requestedCommand in commands) {
  const command = requireCommand(requestedCommand);
  command.run(argv._.slice(1), {onUsageError: explanation => {
    console.log(explanation + '\n\nUsage:\n\n' + commandUsage({commandName: requestedCommand, command}));
  }});
}
else {
  console.log('Usage:\n');
  console.log(Object.keys(commands).map(commandName =>
    commandUsage({commandName})
  ).join('\n'));
}
